title	lptxchg - vertauscht Portadressen von lptn (n=1..4)


biosseg	equ	0040h	; BIOS-Datensegment	


code	segment para
	assume 	cs:code,ds:code
	org	100h

main:	jmp	begin	; Datenbereich berspringen


	; DATEN
	; -----


	; Fehlermeldungen
	; ---------------

wrong	db	'Die Parameter in der Kommandozeile sind unrichtig$'
noparr 	db	'Es sind keine Parameter in der Kommandozeile$'
swap	db	'Portadressen sind ausgetauscht$'
noprint db	'Der angegebene Druckeranschlu ist nicht installiert$'



	;PROGRAMM
	;--------
	
	;DS zeigt bereits auf Segmentvorspann

begin: 	push	ds		; ds sichern
	mov 	si,80h          ; Offset vom Diskettenzwischenspeicher
	xor 	cx,cx           ; CX mit Lnge der Kommandozeile laden
       	mov 	cl,[si]
       	jcxz 	noparaerr       ; Parameter vorhanden?
	cmp	cl,3		; stimmt die Lnge(2 Zeichen)?
	jne	paraerr


lesen: 	mov 	al,[si+2]       ; erstes Zeichen ins AL-Register
	mov	bl,[si+3]	; zweites Zeichen ins bl

	sub	al,48d		; aus ASCII Dezimalzahl
	sub	bl,48d

	push	bx		; bx sichern
	add	bl,al		; Summe der Parameterwerte bilden
	cmp	bl,2		; Summe mu mindestens 3 sein
	jbe	paraerr 	; wenn kleiner, ...
	cmp	bl,8		; Summe darf max 7 (lpt3+lpt4) 
	jae	paraerr		; wenn grer,...
	pop	bx		; bx rckholen

;	Adresstabelle 
;	lpt	offset
;	--------------
;	1  ->	8	
;	2  ->	10
;	3  ->	12
;	4  ->	14		
; 	offset = lpt*2+6

	mov	cx,biosseg
	mov	ds,cx		; Bios-datensegment 40hex als neuer
				; Datenbereich
	xor	si,si		; si lschen
	mov	si,ax		; erste Printernummer
	call	calc 		; offset in si bilden
	mov	cx,word ptr [si]; erste Druckerportadresse zwischenspeichern
	push 	si	     	; ersten offset zwischenspeichern
	cmp	cx,0		; installiert???
	je	printer

	xor	si,si		; si lschen
	mov	si,bx		; zweite Printernummer
	call 	calc		; offset
	mov	dx,word ptr [si]; zweite Adresse speichern
	cmp	cx,0		;installiert???
	je	printer	

	mov	word ptr [si],cx; erste Adresse an Platz der zweiten speichern
	pop	si		; ersten offset
	mov	word ptr [si],dx; zweite Adresse an Platz der ersten speichern

	pop	ds		; altes ds wieder herstellen
	mov	dx,offset swap

message:
	mov	ah,09h		; Stringausgabe
	int	21h
bye:	mov	ah,4ch		; zurck zum DOS
	int 	21h

noparaerr:
	call	beep
	mov	dx,offset noparr
	jmp	message

paraerr:
	call	beep
	mov	dx,offset wrong
	jmp	message 

printer:
	call	beep
	pop	ds
	pop	ds		; mit altem ds
	mov	dx,offset noprint
	jmp	message

;--------------------------------------------------
beep	proc	near
	mov	ah,2
	mov	dl,7
	int	21h
	ret
beep	endp
;----------------------------------------------------
calc	proc	near
	add	si,si	; si verdoppeln
	add	si,6	; Adresse bilden laut Formel
	ret
calc	endp
;----------------------------------------------------

code	ends
	end	main
